package net.za.darkskies.security.sasl;

import java.security.AccessController;
import java.security.PrivilegedAction;

public final class Provider extends java.security.Provider
{

	public Provider()
	{
		super("SSPISASL", 1.0, "Darksies Win32 SSPI SASL provider");

		// Add standard Mechanisms that Sun seem to have forgotten about
		put("SaslServerFactory.EXTERNAL", "net.za.darkskies.security.sasl.StdFactoryImpl");
		put("SaslServerFactory.PLAIN"   , "net.za.darkskies.security.sasl.StdFactoryImpl");

		try 
		{
			// now add SSPI Mechanisms
			String[] clientMechs = SSPIImpl.getClientMechanismNames(null);
			for (int i = 0; i < clientMechs.length; i++)
				put("SaslClientFactory." + clientMechs[i], "net.za.darkskies.security.sasl.ClientFactoryImpl");

			String[] serverMechs = SSPIImpl.getClientMechanismNames(null);
			for (int i = 0; i < serverMechs.length; i++)
				put("SaslServerFactory." + serverMechs[i], "net.za.darkskies.security.sasl.ServerFactoryImpl");
		}
		catch (UnsatisfiedLinkError ule)
		{
			// if the native SSPI libraries are not around, don't display an error
			//  this is kinda crap if someone is trying to debug why the libs won't load
			//  but it means that you can use this library on another OS without getting
			//  errors each time you start an application that uses sasl
			ule.printStackTrace();
		}
		catch (Throwable th)
		{
			th.printStackTrace();
		}
	}
}
